[PATCH bpf-next] selftests, bpf: Skip MPLS test_tc_tunnel tests if MPLS is unavailable

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



If MPLS is not available in the kernel then skip MPLS tests.

This avoids the test failing in situations where the test is not
supported by the underlying kernel.

In the case where all tests are run, just skip over the MPLS tests
without altering the exit code of the overall test run - there
is only one exit code in this scenario.

In the case where a single test is run, exit with KSFT_SKIP (4).

In both cases log an informative message.

Signed-off-by: Simon Horman <horms@xxxxxxxxxx>
---
 tools/testing/selftests/bpf/test_tc_tunnel.sh | 22 ++++++++++++++++++++--
 1 file changed, 20 insertions(+), 2 deletions(-)

diff --git a/tools/testing/selftests/bpf/test_tc_tunnel.sh b/tools/testing/selftests/bpf/test_tc_tunnel.sh
index 7989ec608454..71cddabc4ade 100755
--- a/tools/testing/selftests/bpf/test_tc_tunnel.sh
+++ b/tools/testing/selftests/bpf/test_tc_tunnel.sh
@@ -102,6 +102,20 @@ wait_for_port() {
 	return 1
 }
 
+skip_mac() {
+	if [ "$1" = "mpls" ]; then
+		modprobe mpls_iptunnel || true
+		modprobe mpls_gso || true
+
+		if [ ! -e /proc/sys/net/mpls/platform_labels ]; then
+			echo -e "skip:    mpls tunnel not supported by kernel\n"
+			return # true
+		fi
+	fi
+
+	false
+}
+
 set -e
 
 # no arguments: automated test, run all
@@ -125,6 +139,8 @@ if [[ "$#" -eq "0" ]]; then
 	$0 ipv6 ip6vxlan eth 2000
 
 	for mac in none mpls eth ; do
+		! skip_mac "$mac" || continue
+
 		echo "ip gre $mac"
 		$0 ipv4 gre $mac 100
 
@@ -193,6 +209,10 @@ readonly tuntype=$2
 readonly mac=$3
 readonly datalen=$4
 
+if skip_mac "$mac"; then
+	exit 4 # KSFT_SKIP=4
+fi
+
 echo "encap ${addr1} to ${addr2}, type ${tuntype}, mac ${mac} len ${datalen}"
 
 trap cleanup EXIT
@@ -278,8 +298,6 @@ elif [[ "$tuntype" =~ (gre|vxlan) && "$mac" == "eth" ]]; then
 		  awk '/ether/ { print $2 }')
 	ip netns exec "${ns2}" ip link set testtun0 address $ethaddr
 elif [[ "$mac" == "mpls" ]]; then
-	modprobe mpls_iptunnel ||true
-	modprobe mpls_gso ||true
 	ip netns exec "${ns2}" sysctl -qw net.mpls.platform_labels=65536
 	ip netns exec "${ns2}" ip -f mpls route add 1000 dev lo
 	ip netns exec "${ns2}" ip link set lo up





[Index of Archives]     [Linux Samsung SoC]     [Linux Rockchip SoC]     [Linux Actions SoC]     [Linux for Synopsys ARC Processors]     [Linux NFS]     [Linux NILFS]     [Linux USB Devel]     [Video for Linux]     [Linux Audio Users]     [Yosemite News]     [Linux Kernel]     [Linux SCSI]


  Powered by Linux